/*
 * Part of the GaBIEn project.
 * (Graphics and Basic Input Engine)
 *
 *        DO WHATEVER YOU WANT TO PUBLIC LICENSE 
 *                    Version 2, December 2004 
 *
 * Modified by gamemanj <asdd2808@gmail.com> to remove expletives
 * Original copyright (C) 2004 Sam Hocevar <sam@hocevar.net> 
 *
 * Everyone is permitted to copy and distribute verbatim or modified 
 * copies of this license document, and changing it is allowed as long 
 * as the name is changed. 
 *
 *            DO WHATEVER YOU WANT TO PUBLIC LICENSE 
 *   TERMS AND CONDITIONS FOR COPYING, DISTRIBUTION AND MODIFICATION 
 *
 *  0. You just DO WHATEVER YOU WANT TO.
 */
package gabien;

import java.io.InputStream;

public class GaBIEn {
	protected static IGaBIEn internal;
	public static double getTime() {return internal.getTime();}
	public static double timeDelta(boolean reset) {return internal.timeDelta(reset);}
	public static InputStream getResource(String resource) {return internal.getResource(resource);}
	public static InputStream getFile(String resource) {return internal.getFile(resource);}
	public static boolean singleWindowApp() {return internal.singleWindowApp();}
	public static ISoundDriver getSound() {return internal.getSound();}
	public static void ensureQuit() {internal.ensureQuit();}
	public static WindowSpecs defaultWindowSpecs(String name,int w,int h) {return internal.defaultWindowSpecs(name,w,h);}
	public static IGrInDriver makeGrIn(String name,int w,int h)
	{
        WindowSpecs ws=defaultWindowSpecs(name,w,h);
        return makeGrIn(name,w,h,ws);
	}
	public static IGrInDriver makeGrIn(String name,int w,int h,WindowSpecs specs) {return internal.makeGrIn(name, w, h,specs);}
}
