/*
 * Part of the JavaChan project.
 * (Java ikaChan)
 *
 *        DO WHATEVER YOU WANT TO PUBLIC LICENSE 
 *                    Version 2, December 2004 
 *
 * Modified by gamemanj <asdd2808@gmail.com> to remove expletives
 * Original copyright (C) 2004 Sam Hocevar <sam@hocevar.net> 
 *
 * Everyone is permitted to copy and distribute verbatim or modified 
 * copies of this license document, and changing it is allowed as long 
 * as the name is changed. 
 *
 *            DO WHATEVER YOU WANT TO PUBLIC LICENSE 
 *   TERMS AND CONDITIONS FOR COPYING, DISTRIBUTION AND MODIFICATION 
 *
 *  0. You just DO WHATEVER YOU WANT TO.
 */
package javachan;

import gabien.GaBIEn;
import gabien.IGrInDriver;
import java.util.logging.Level;
import java.util.logging.Logger;

import javachan.games.LauncherGame;

/**
 * Acts as a place for all the 'interchangable' parts to go. In other
 * words,graphics,music,gamestate...
 * 
 * @author matt
 */
public class Game {
    public static final int SYSTEM_VERSION = 15;
    public IGrInDriver graphics;
    public IMusicDriver music;
    public IGame gameState;

    public void resetGame(boolean Editor) {
        if (Editor) {
            GameState gs = new GameState();
            try {
                gs.map.loadBitmap(GaBIEn.getFile("Pbm/Map1.pbm"));
                gs.npcs.load(GaBIEn.getFile("NPChar.dat"));
            } catch (Exception ex) {
                Logger.getLogger(Game.class.getName()).log(Level.SEVERE, null,
                        ex);
            }
            gameState = new javachan.games.EditorGame(gs);
        } else {
            gameState = new javachan.games.OpeningGame();
        }
    }

    public void runFrame() {
        while (GaBIEn.timeDelta(false) < 0.02) {
            Thread.yield();
        }
        double deltaTime = GaBIEn.timeDelta(true);
        music.doUpdate(deltaTime);
        gameState.doUpdate(deltaTime, GaBIEn.getTime(), this);
    }

    public void resetInitLauncher() {
        graphics = GaBIEn.makeGrIn("IME", 96, 96);
        if (GaBIEn.singleWindowApp()) {
            resetGame(false);
        } else {
            gameState = new LauncherGame();
        }

        music = new MusicDriver_InternalPlayer();
    }
}
