/*
 * Part of the JavaChan project.
 * (Java ikaChan)
 *
 *        DO WHATEVER YOU WANT TO PUBLIC LICENSE 
 *                    Version 2, December 2004 
 *
 * Modified by gamemanj <asdd2808@gmail.com> to remove expletives
 * Original copyright (C) 2004 Sam Hocevar <sam@hocevar.net> 
 *
 * Everyone is permitted to copy and distribute verbatim or modified 
 * copies of this license document, and changing it is allowed as long 
 * as the name is changed. 
 *
 *            DO WHATEVER YOU WANT TO PUBLIC LICENSE 
 *   TERMS AND CONDITIONS FOR COPYING, DISTRIBUTION AND MODIFICATION 
 *
 *  0. You just DO WHATEVER YOU WANT TO.
 */
package javachan.music;

import java.io.IOException;
import java.io.InputStream;

public class PiyoPiyoFile {
    public PiyoPiyoWaveTrack[] waveTracks = new PiyoPiyoWaveTrack[3];
    public int musicWait, drumVolume, loopStart, loopEnd;
    public PiyoPiyoFrame[] musicFrames;

    public PiyoPiyoFile(int musicLength) {
        musicFrames = new PiyoPiyoFrame[musicLength * 4];
        for (int i = 0; i < musicFrames.length; i++)
            musicFrames[i] = new PiyoPiyoFrame();
        waveTracks[0] = new PiyoPiyoWaveTrack();
        waveTracks[1] = new PiyoPiyoWaveTrack();
        waveTracks[2] = new PiyoPiyoWaveTrack();
    }

    public void loadFile(InputStream is) throws IOException {
        if ((read8(is) != ((int) 'P')) || (read8(is) != ((int) 'M'))
                || (read8(is) != ((int) 'D')) || (read8(is) != 0x80))
            throw new IOException("Not a PMD file!");
        int pos = read32(is) - 0x418;
        musicWait = read32(is);
        loopStart = read32(is);
        loopEnd = read32(is);
        musicFrames = new PiyoPiyoFrame[read32(is) * 4];
        waveTracks[0].read(is);
        waveTracks[1].read(is);
        waveTracks[2].read(is);
        drumVolume = read32(is);
        is.skip(pos);
        for (int i = 0; i < musicFrames.length; i++) {
            musicFrames[i] = new PiyoPiyoFrame();
            musicFrames[i].read(is);
        }
    }

    protected static int read8(InputStream is) throws IOException {
        int i = is.read();
        if (i == -1)
            throw new IOException("Unexpected EOF");
        return i;
    }

    protected static int read32(InputStream is) throws IOException {
        int i = read8(is);
        i |= read8(is) << 8;
        i |= read8(is) << 16;
        i |= read8(is) << 24;
        return i;
    }

    protected static void readArray(InputStream is, int[] b) throws IOException {
        for (int i = 0; i < b.length; i++)
            b[i] = read8(is);
    }
}
