/*
 * Part of the JavaChan project.
 * (Java ikaChan)
 *
 *        DO WHATEVER YOU WANT TO PUBLIC LICENSE 
 *                    Version 2, December 2004 
 *
 * Modified by gamemanj <asdd2808@gmail.com> to remove expletives
 * Original copyright (C) 2004 Sam Hocevar <sam@hocevar.net> 
 *
 * Everyone is permitted to copy and distribute verbatim or modified 
 * copies of this license document, and changing it is allowed as long 
 * as the name is changed. 
 *
 *            DO WHATEVER YOU WANT TO PUBLIC LICENSE 
 *   TERMS AND CONDITIONS FOR COPYING, DISTRIBUTION AND MODIFICATION 
 *
 *  0. You just DO WHATEVER YOU WANT TO.
 */
package javachan.music;

import gabien.ISoundDriver;

import java.io.DataOutputStream;
import java.io.FileInputStream;
import java.io.FileOutputStream;
import java.io.IOException;
import java.util.LinkedList;

public class PiyoPiyoPlayer {

    //Notes & Samples
    public LinkedList<PiyoPiyoPlayingNote> playingNotes=new LinkedList<PiyoPiyoPlayingNote>();
    public LinkedList<PiyoPiyoPlayingSample> playingSamples=new LinkedList<PiyoPiyoPlayingSample>();

    public double withinBeatPosition = 0;
    public PiyoPiyoFile piyoFile;
    public ISoundDriver sound;
    public int currentFrame=0;
    public PiyoPiyoPlayer(FileInputStream fis, ISoundDriver sound) throws IOException {
        this.sound=sound;
        piyoFile = new PiyoPiyoFile(1);
        piyoFile.loadFile(fis);
        /*
        FileOutputStream fos=new FileOutputStream("piyoDrums.bin");
        DataOutputStream dos=new DataOutputStream(fos);
        for (int i=0;i<6;i++)
        {
            FileInputStream is=new FileInputStream("D"+(i+1)+".raw");
            int b=is.available();
            dos.writeInt(b);
            for (int j=0;j<b;j++)
                dos.write(is.read());
            is.close();
        }
        dos.close();*/
    }

    public void doUpdate(double deltaTime) {
        withinBeatPosition += deltaTime;
        if (withinBeatPosition > (piyoFile.musicWait/1000.0d)) {
            withinBeatPosition -= (piyoFile.musicWait/1000.0d);
            if (((currentFrame*4)>=piyoFile.musicFrames.length)||
                    (currentFrame>=piyoFile.loopEnd))
            {
                currentFrame=piyoFile.loopStart;
            }
            for (int i=0;i<3;i++)
                handleTrackBeat(piyoFile.musicFrames[currentFrame+((piyoFile.musicFrames.length/4)*i)],piyoFile.waveTracks[i]);
            handleDrumBeat(piyoFile.musicFrames[currentFrame+((piyoFile.musicFrames.length/4)*3)]);
            currentFrame++;
        }
        for (PiyoPiyoPlayingNote note : ((LinkedList<PiyoPiyoPlayingNote>)playingNotes.clone()))
        {
            if (note.updateEnvelope(deltaTime))
            {
                sound.deleteChannel(note.channel);
                playingNotes.remove(note);
            }
        }
        for (PiyoPiyoPlayingSample note : ((LinkedList<PiyoPiyoPlayingSample>)playingSamples.clone()))
        {
            if (note.doUpdate(deltaTime))
            {
                sound.deleteChannel(note.channel);
                playingSamples.remove(note);
            }
        }
    }

    private void handleDrumBeat(PiyoPiyoFrame piyoPiyoFrame) {
        for (int i=0;i<24;i++)
        {
            if (piyoPiyoFrame.hitNotes[i])
            {
                playingSamples.add(new PiyoPiyoPlayingSample(sound.createChannel(),i,piyoFile.drumVolume,piyoPiyoFrame.panValue));
            }
        }
    }

    private void handleTrackBeat(PiyoPiyoFrame piyoPiyoFrame,
            PiyoPiyoWaveTrack piyoPiyoWaveTrack) {
        for (int i=0;i<24;i++)
        {
            if (piyoPiyoFrame.hitNotes[i])
            {
                playingNotes.add(new PiyoPiyoPlayingNote(sound.createChannel(), piyoPiyoWaveTrack, i, piyoPiyoFrame.panValue));
            }
        }
    }
    
    public void stopAll()
    {
        for (PiyoPiyoPlayingNote note : playingNotes)
        {
            sound.deleteChannel(note.channel);
        }
        for (PiyoPiyoPlayingSample note : playingSamples)
        {
            sound.deleteChannel(note.channel);
        }
        playingNotes.clear();
        playingSamples.clear();
    }
}
