/*
 * Part of the JavaChan project.
 * (Java ikaChan)
 *
 *        DO WHATEVER YOU WANT TO PUBLIC LICENSE 
 *                    Version 2, December 2004 
 *
 * Modified by gamemanj <asdd2808@gmail.com> to remove expletives
 * Original copyright (C) 2004 Sam Hocevar <sam@hocevar.net> 
 *
 * Everyone is permitted to copy and distribute verbatim or modified 
 * copies of this license document, and changing it is allowed as long 
 * as the name is changed. 
 *
 *            DO WHATEVER YOU WANT TO PUBLIC LICENSE 
 *   TERMS AND CONDITIONS FOR COPYING, DISTRIBUTION AND MODIFICATION 
 *
 *  0. You just DO WHATEVER YOU WANT TO.
 */
package javachan.npcs;

import javachan.GameState;
import javachan.GameStateNPChar;
import javachan.GameStateNPChar.NPCCharacter;
import javachan.IEventCallback;
import gabien.IGrInDriver;
import gabien.IGrInDriver.IImage;
import gabien.ui.Rect;

/**
 *
 * @author matt
 */
public class BasicNPCType {
    public Rect GetRectangle(GameStateNPChar.NPCCharacter In) {
        return new Rect((int) (In.posX * 16) + 1, (int) (In.posY * 16) + 1, 14, 14);
    }

    public void HitWorld(GameStateNPChar.NPCCharacter In, int bdir) {
    }

    public boolean hasPhysics() {
        return false;
    }

    public String[] NpcImg = { "AlreadyImplemented", "AlreadyImplemented",
            "AlreadyImplemented", "AlreadyImplemented", "Pbm/Chibi.pbm",
            "AlreadyImplemented", "Pbm/Dum.pbm", "Pbm/Carry.pbm",
            "Pbm/Juel.pbm", "Pbm/Ufo.pbm" };

    public void Draw(int px, int py, double Time,
            GameStateNPChar.NPCCharacter In, GameState gs, IGrInDriver graphics) {
        int Type = In.entityType;
        IImage npci = graphics.getImage(NpcImg[Type], 0, 0, 0);
        int xx = 0;
        int yy = 0;
        int ww = 16;
        int hh = 16;
        int ox = 0;
        int oy = 0;
        if (Type == 4) {
            xx = 0;
            yy = 0;
            ox = 4;
            oy = 4;
            ww = 8;
            hh = 8;
        }
        if (Type == 6) {
            xx = ((int) In.ofsX) * 16;
        }
        if (Type == 7) {
            xx = 0;
            yy = 0;
            ww = npci.getWidth() / 2;
            hh = npci.getHeight() / 2;
            ox = 8 - (ww / 2);
            oy = 8 - (hh / 2);
        }
        if (Type == 9) {
            xx = 0;
            yy = 0;
            ww = npci.getWidth();
            hh = npci.getHeight();
            oy = -(hh / 2);
        }

        if (npci == null) {
            System.out.println("BAD NPCTYPE " + Type);
        } else {
            graphics.blitBCKImage(xx, yy, ww, hh, (int) (In.posX * 16) + px + ox,
                    (int) (In.posY * 16) + py + oy, npci);
        }

    }

    public void doTick(NPCCharacter npc, GameState gs, double Time) {

    }

    protected void HurtIkachan(GameState gs) {
        gs.applyXPEnergy(0, -touchDamage());
    }

    protected void HurtEnemy(GameState gs, NPCCharacter In, IEventCallback iec) {
        gs.applyXPEnergy(rewardXP(), 0);
        In.exists = false;
        if (In.collisionType == 2)
            iec.startEvent(In.eventID);
    }

    // -1:Not needed,0:Left,1:Right,2:Up,3:Down

    public void ikachanTouchedEnemy(NPCCharacter In, GameState gs, int r,
            IEventCallback iec) {
        if (r == 3) {
            if (gs.playerLevel >= levelToHurt()) {
                if (gs.hasItem(1)) {
                    HurtEnemy(gs, In, iec);
                }
            } else {
                // TODO:Sound:Bounced off!
            }
        } else {
            HurtIkachan(gs);
        }

    }

    protected int touchDamage() {
        return 0;
    }

    protected int levelToHurt() {
        return 0;
    }

    protected int rewardXP() {
        return 0;
    }
}
