/*
 * Part of the JavaChan project.
 * (Java ikaChan)
 *
 *        DO WHATEVER YOU WANT TO PUBLIC LICENSE 
 *                    Version 2, December 2004 
 *
 * Modified by gamemanj <asdd2808@gmail.com> to remove expletives
 * Original copyright (C) 2004 Sam Hocevar <sam@hocevar.net> 
 *
 * Everyone is permitted to copy and distribute verbatim or modified 
 * copies of this license document, and changing it is allowed as long 
 * as the name is changed. 
 *
 *            DO WHATEVER YOU WANT TO PUBLIC LICENSE 
 *   TERMS AND CONDITIONS FOR COPYING, DISTRIBUTION AND MODIFICATION 
 *
 *  0. You just DO WHATEVER YOU WANT TO.
 */
package javachan.npcs;

import javachan.GameState;
import javachan.GameStateNPChar;
import javachan.GameStateNPChar.NPCCharacter;
import javachan.IEventCallback;
import gabien.IGrInDriver;
import gabien.IGrInDriver.IImage;

/**
 *
 * @author matt
 */
public class CrabNPCType extends BasicNPCType {

    @Override
    public boolean hasPhysics() {
        return true;
    }
    
    @Override
    public void Draw(int px,int py,double Time,GameStateNPChar.NPCCharacter In,GameState gs,IGrInDriver graphics)
    {
        int LR = 2;
        if (gs.playerX < In.posX) {
            LR = 0;
        }
        if (gs.playerX > In.posX) {
            LR = 1;
        }
        IImage npci=graphics.getImage("Pbm/Kani.pbm", 0, 0, 0);
        int ox=0;
        int oy=0;
        int ww=16;
        int hh=16;
        int xx=((((int)Math.floor(Time*2.0))&1)==0)?16:0;
        int yy=((In.entityStatus2&1)==1)?16:0;
        if (npci==null)
        {
            System.out.println("MISSING IMAGE FOR ("+getClass().getName()+")");
        } else{
            graphics.blitBCKImage(xx, yy, ww, hh, (int) (In.posX * 16) + px + ox, (int) (In.posY * 16) + py + oy, npci);
        }
    }

    @Override
    public void doTick(NPCCharacter npc, GameState gs, double Time) {
        npc.setVY(npc.getVY()+0.0025);
        double d=npc.getVX();
        boolean sign=d<0;
        if (sign) d=-d;
        d-=d*0.025;
        npc.setVX(d*(sign?-1:1));

        int LR = 0;
        if (gs.playerX < npc.posX) {
            LR = -1;
        }
        if (gs.playerX > npc.posX) {
            LR = 1;
        }
        
        //Important
        double TV=0.05;
        if ((npc.entityStatus2&1)==1)
        {
            if (npc.velY>0)
            {
            npc.entityStatus2^=1;
            npc.entityStatus2^=2;
            ChangeDir(npc);
            }
        } else if ((npc.entityStatus2&2)==2)
        {
            if (npc.onGround)
            {
                npc.entityStatus2^=2;
                ChangeDir(npc);
            }
        } else {
            if (((npc.entityStatus2>>6)&0x1F)==0)
            {
                if (npc.onGround)
                {
                ChangeDir(npc);
                npc.entityStatus2^=1;
                npc.entityStatus2|=0x1F<<6;
                npc.velY=-0.15;
                }
            } else {
                npc.entityStatus2-=1<<6;
                
            }
        }
        if ((npc.entityStatus2&(1<<15))==0) npc.velX+=TV/20;
        if ((npc.entityStatus2&(1<<15))==(1<<15)) npc.velX-=TV/20;
        if (npc.velX>TV) npc.velX=TV;
        if (npc.velX<-TV) npc.velX=-TV;
    }
    //must be a power of 2 in length.
    boolean[] movetable=new boolean[] {false,false,true,false,false,false};
    //Yes,I know this is a weird way of doing this.
    private void ChangeDir(NPCCharacter npc) {
        boolean b=movetable[(npc.entityStatus2>>2)&0xF];
        if (b)
        {
            npc.entityStatus2^=1<<15;
        }
        if (((npc.entityStatus2>>2)&0xF)==movetable.length-1)
        {
        npc.entityStatus2^=(movetable.length-1)<<2;
        } else {
        npc.entityStatus2+=1<<2;
        }
    }
    @Override
    public void ikachanTouchedEnemy(NPCCharacter In, GameState gs, int r,IEventCallback iec) {
        if (r==3)
        {
            if (gs.playerLevel>=levelToHurt())
            {
               if (gs.hasItem(1))
               {
                   HurtEnemy(gs,In,iec);
               }
            } else {
                //TODO:Sound:Bounced off!
            }
        }
        if ((In.entityStatus2&1)==1)
        HurtIkachan(gs);
    }
    @Override
    protected int touchDamage()
    {
        return 2;
    }
    @Override
    protected int levelToHurt()
    {
        return 2;
    }
    @Override
    protected int rewardXP()
    {
        return 3;
    }
}
