/*
 * Part of the JavaChan project.
 * (Java ikaChan)
 *
 *        DO WHATEVER YOU WANT TO PUBLIC LICENSE 
 *                    Version 2, December 2004 
 *
 * Modified by gamemanj <asdd2808@gmail.com> to remove expletives
 * Original copyright (C) 2004 Sam Hocevar <sam@hocevar.net> 
 *
 * Everyone is permitted to copy and distribute verbatim or modified 
 * copies of this license document, and changing it is allowed as long 
 * as the name is changed. 
 *
 *            DO WHATEVER YOU WANT TO PUBLIC LICENSE 
 *   TERMS AND CONDITIONS FOR COPYING, DISTRIBUTION AND MODIFICATION 
 *
 *  0. You just DO WHATEVER YOU WANT TO.
 */
package javachan.npcs;

import javachan.GameState;
import javachan.GameStateNPChar;
import javachan.GameStateNPChar.NPCCharacter;
import gabien.IGrInDriver;
import gabien.IGrInDriver.IImage;
import gabien.ui.Rect;

/**
 *
 * @author matt
 */
public class SleepNPCType extends BasicNPCType {
    @Override
    public Rect GetRectangle(GameStateNPChar.NPCCharacter In)
    {
        return new Rect((int)(In.posX*16)+3,(int)(In.posY*16)+6,10,10);
    }    
    @Override
    public void doTick(NPCCharacter npc, GameState gs, double Time) {
        boolean in=new Rect((int)(npc.posX*16)-16,(int)(npc.posY*16)-16,48,48).contains((int)(gs.getX()*16), (int)(gs.getY()*16));
        if (in)
        {
            if (npc.entityStatus2<12)
            npc.entityStatus2++;
        } else {
            if (npc.entityStatus2>0)
            npc.entityStatus2--;
        }
    }    
    @Override
    public void Draw(int px,int py,double Time,GameStateNPChar.NPCCharacter In,GameState gs,IGrInDriver graphics)
    {
        IImage npci=graphics.getImage("Pbm/Sleep.pbm", 0, 0, 0);
        int s=(In.entityStatus2/3)-1;
        if (s<0) s=0;
        int xx=(s%2)==1 ? (npci.getWidth()/2):0;
        int yy=(s/2)==1 ? (npci.getHeight()/2):0;
        int ww=npci.getWidth()/2;
        int hh=npci.getHeight()/2;
        int ox=8-(npci.getWidth()/4);
        int oy=-((npci.getHeight()/2)-16);
        if (npci==null)
        {
        	//Supposedly,this is "dead code".Yeah,I don't believe it either
            System.out.println("MISSING IMAGE FOR ("+getClass().getName()+")");
        } else{
            graphics.blitBCKImage(xx, yy, ww, hh, (int) (In.posX * 16) + px + ox, (int) (In.posY * 16) + py + oy, npci);
        }
    }
}
